/* EXAMPLE OF I/O STATEMENTS */
#include "bc.h"
main() {
char *S = "STRING", *FLNAME = "TDAT.G";
int A = 234, B = 678;
if((fp1=fopen( "DATA.TST", "w"))==0){puts("can't open #1");exit(1);}
fprintf(fp1, "%s %d %d", S, A, B);
fclose(fp1);
if((fp1=fopen( "DATA.TST", "r"))==0){puts("can't open #1");exit(1);}
IEOF = fscanf(fp1, "%s %d %d", S, &A, &B);
fclose(fp1);
printf("%s %d %d \n", S, A, B);
LIST(FLNAME);
}/* IOEX*/

LIST(FILENAME)
char *FILENAME;
{
char C;
if((fp4=fopen( FILENAME, "r"))==0){puts("can't open #4");exit(1);}
while((C = getc(fp4)) != EOF) {
  putchar(C);
}/*WH*/
fclose(fp4);
}/* LIST*/

/* ERATOSTHENES SIEVE */
#include "bc.h"
#define SIZE 8190
main() {
int ITER, COUNT, I, K;
int PRIME, FLAG[8191];
printf("10 ITERATIONS \n");
for(ITER = 1; ITER <= 10; ITER++) {
  COUNT = 0;
  for(I = 0; I <= SIZE; I++) {
    FLAG[I] = 1;
  }/*I*/
  for(I = 0; I <= SIZE; I++) {
    if(FLAG[I] != 0) {
      PRIME = I+I+3;
      K = I + PRIME;
      while(K <= SIZE) {
        FLAG[K] = 0;
        K = K + PRIME;
     e(BRANCH);
	chain = NULL;
	while (*regparse != '\0' && *regparse != '|' && *regparse != ')') {
		latest = regpiece(&flags);
		if (latest == NULL)
			return(NULL);
		*flagp |= flags&HASWIDTH;
		if (chain == NULL)	/* First piece. */
			*flagp |= flags&SPSTART;
		else
			regtail(chain, latest);
		chain = latest;
	}
	if (chain == NULL)	/* Loop ran zero times. */
		(void) regnode(NOTHING);

	return(ret);
}

/*
 - regpiece - something followed by possible [*+?]
 *
 * Note that the branching code sequences used for ? and the general cases
 * of * and + are somewhat optimized:  they use the same NOTHING node as
 * both the endmarker for their branch list and the body of the last branch.
 * It might seem that this node could be dispensed with entirely, but the
 * endmarker role is not redundant.
 */
static char *
regpiece(flagp)
int *flagp;
{
	register char *ret;
	register char op;
	register char *next;
	int flags;

	ret = regatom(&flags);
	if (ret == NULL)
		return(NULL);

	op = *regparse;
	if (!ISMULT(op)) {
		*flagp = flags;
		return(ret);
	}

	if (!(flags&HASWIDTH) && op != '?')
		FAIL("*+ operand could be empty");
	*flagp = (op != '+') ? (WORST|SPSTART) : (WORST|HASWIDTH);

	if (op == '*' && (flags&SIMPLE))
		reginsert(STAR, ret);
	else if (op == '*') {
		/* Emit x* as (x&|), where & means "self". */
		reginsert(BRANCH, ret);			/* Either x */
		regoptail(ret, regnode(BACK));		/* and loop */
		regoptail(ret, ret);			/* back */
		regtail(ret, regnode(BRANCH));		/* or */
		regtail(ret, regnode(NOTHING));		/* null. */
	} else if (op == '+' && (flags&SIMPLE))
		reginsert(PLUS, ret);
	else if (op == '+') {
		/* Emit x+ as x(&|), where & means "self". */
		next = regnode(BRANCH);			/* Either */
		regtail(ret, next);
		regtail(regnode(BACK), ret);		/* loop back */
		regtail(next, regnode(BRANCH));		/* or */
		regtail(ret, regnode(NOTHING));		/* null. */
	} else if (op == '?') {
		/* Emit x? as (x|) */
		reginsert(BRANCH, ret);			/* Either x */
		regtail(ret, regnode(BRANCH));		/* or */
		next = regnode(NOTHING);		/* null. */
		regtail(ret, next);
		regoptail(ret, next);
	}
	regparse++;
	if (ISMULT(*regparse))
		FAIL("nested *?+");

	return(ret);
}

/*
 - regatom - the lowest level
 *
 * Optimization:  gobbles an entire sequence of ordinary characters so that
 * it can turn them into a single node, which is smaller to store and
 * faster to run.  Backslashed characters are exceptions, each becoming a
 * separate node; the code is simpler that way and it's not worth fixing.
 */
static char *
regatom(flagp)
int *flagp;
{
	register char *ret;
	int flags;

	*flagp = WORST;		/* Tentatively. */

	switch (*regparse++) {
	case '^':
		ret = regnode(BOL);
		break;
	case '$':
		ret = regnode(EOL);
		break;
	case '.':
		ret = regnode(ANY);
		*flagp |= HASWIDTH|SIMPLE;
		break;
	case '[': {
			register int class;
			register int classend;

			if (*regparse == '^') {	/* Complement of range. */
				ret = regnode(ANYBUT);
				regparse++;
			} else
				ret = regnode(ANYOF);
			if (*regparse == ']' || *regparse == '-')
				regc(*regparse++);
			while (*regparse != '\0' && *regparse != ']') {
				if (*regparse == '-') {
					regparse++;
					if (*regparse == ']' || *regparse == '\0')
						regc('-');
					else {
						class = UCHARAT(regparse-2)+1;
						classend = UCHARAT(regparse);
						if (class > classend+1)
							FAIL("invalid [] range");
						for (; class <= classend; class++)
							regc(class);
						regparse++;
					}
				} else
					regc(*regparse++);
			}
			regc('\0');
			if (*regparse != ']')
				FAIL("unmatched []");
			regparse++;
			*flagp |= HASWIDTH|SIMPLE;
		}
		break;
	case '(':
		ret = reg(1, &flags);
		if (ret == NULL)
			return(NULL);
		*flagp |= flags&(HASWIDTH|SPSTART);
		break;
	case '\0':
	case '|':
	case ')':
		FAIL("internal urp");	/* Supposed to be caught earlier. */
		break;
	case '?':
	case '+':
	case '*':
		FAIL("?+* follows nothing");
		break;
	case '\\':
		if (*regparse == '\0')
			FAIL("trailing \\");
		ret = regnode(EXACTLY);
		regc(*regparse++);
		regc('\0');
		*flagp |= HASWIDTH|SIMPLE;
		break;
	default: {
			 }/*WH*/
      COUNT++;
    }/*IF*/
  }/*I*/
}/*ITER*/
printf(" %d PRIMES \n", COUNT);
}/* SIEVE*/

/* EIGHT QUEENS CHESS PROBLEM */
#include "bc.h"
int COLFREE[8], X[8];
int UPFREE[15], DOWNFREE[15];
int R, K;
main() {
/* INITIALIZE EMPTY BOARD */
for(K = 0; K <= 7; K++) {
  COLFREE[K] = TRUE;
}/*K*/
for(K = 0; K <= 14; K++) {
  UPFREE[K] = DOWNFREE[K] = TRUE;
}/*K*/
R = -1;
ADDQUEEN();
}/* QUEEN8*/

ADDQUEEN()
{
int C;
R++;
for(C = 0; C <= 7; C++) {
  /* IS SQUARE[R,C] FREE? */
  if(COLFREE[C] && UPFREE[R-C+7] && DOWNFREE[R+C]) {
    /* SET QUEEN ON SQUARE[R,C] */
    X[R] = C;
    COLFREE[C] = UPFREE[R-C+7] = DOWNFREE[R+C] = FALSE;
    if(R == 7) {
      printf("\n CONFIGURATION \n");
      for(K = 0; K <= 7; K++) {
        printf(" %d", X[K]);
      }/*K*/
      exit(1);
    ELSE ADDQUEEN();
    }/*IF*/
    /* REMOVE QUEEN FROM SQUARE[R,C)] */
    COLFREE[C] = UPFREE[R-C+7] = DOWNFREE[R+C] = TRUE;
  }/*IF*/
}/*C*/
R--;
}/* ADDQUEE