#include "vbios.h"

void	vb_scroll( x_left, x_right, y_top, y_bottom, amt, attrib )
{
    /* Scroll the indicated region on the screen.
     * If amt is negative, scroll down.
     */

    union REGS	regs;

    if( amt < 0 )
    {
	regs.h.ah = 7    ;
	regs.h.al = -amt ;
    }
    else
    {
	regs.h.ah = 6   ;
	regs.h.al = amt ;
    }

    regs.h.bh = attrib  ;
    regs.h.cl = x_left  ;
    regs.h.ch = y_top   ;
    regs.h.dl = x_right ;
    regs.h.dh = y_bottom ;

    int86(0x10, &regs, &regs);
}
