	}

		if( !*rval )
			rval = NULL;
	}

	return rval;
}

/*----------------------------------------------------------------------*/

void	unsetvar( name )
char	*name;
{
	/*	If the variable called name exists, delete it.
	 */

	register VAR	*p	;
	register VAR	*lastp	;

	if( !(*name & 0x7f) )
		return;

	for( p = Varlist; p != NULL ; lastp = p, p = p->next)
	{
		if( !strncmp(name, p->name, NAMELEN) )
		{
			if( Varlist == Lastvar )	    /* 1 object only */
				Varlist = Lastvar = NULL;   /* in list       */

			else if( p == Varlist ) 	    /* first object  */
				Varlist = p->next;	    /* in list	     */
			else
			{
				lastp->next = p->next;	    /* p in middle   */
							    /* of list	     */
							    /* ... or ...    */
				if( p == Lastvar )	    /* last object   */
					Lastvar = lastp;    /* in list	     */
			}

			free( p );
			break;
		}
	}
}

/*----------------------------------------------------------------------*/

int	setvar( name, val )
char	*name, *val;
{
	/*	Set the value of the variable "name" to "val". If it
	 *	already exists, change it. The last node in the list
	 *	has NULL in its "next" field. The strings are
	 *	copied into malloc()ed memory.
	 */

	register VAR	*vp;

	if( *name )
	{
		unsetvar( name );

		if( !(vp = (VAR *) malloc(sizeof(VAR) + strlen(val))) )
		{
		    syserr("sh: Insufficient memory to create alias\n");
		    return 0;
		}

		strncpy ( vp->name, name, NAMELEN+1 );
		strcpy  ( vp->val,  val 	    );

		vp->next  = NULL;

		if( !Varlist )
			Varlist = vp;
		else
			Lastvar->next = vp;

		Lastvar = vp;
	}

	return 1;
}

/*----------------------------------------------------------------------
 * All routines in this module may be used for both aliases and shell
 * variables except for the two print routines. Alias's have
 * the high bit if the first character of the name s