#include "vbios.h"

void	vb_cursize( top_line, bot_line )
{
    /* Scan lines are numberd 0 at the top and 7 at the
     * bottom on the color card. On the monochrome card
     * they're 0-12. If top & bot are reversed you'll
     * get a 2 part cursor. Top_line determines the
     * position of the top scan line of the cursor,
     * bot_line is the bottom. A normal cursor can be
     * created with vb_cursize(6,7). Cursize(0,7) will
     * fill the entire area occupied by a character.
     * Cursize(0,1) will put a line over the character
     * rather than under it.
     */

    union REGS	regs;

    regs.h.ch = top_line ;
    regs.h.cl = bot_line ;
    regs.h.ah = CUR_SIZE ;
    int86( VIDEO_INT, &regs, &regs );
}
