#include "vbios.h"

void	vb_outcha( c )
{
    /* Write out a character and attribute without moving
     * the cursor. The attibute is in the high byte of c,
     * the character in the low byte.
     */

    union REGS	regs;

    regs.h.ah = 10 ;
    regs.h.al = c;	/* write c			*/
    regs.h.bl = c >> 8; /* with the indicated attribute */
    regs.h.bh = 0;	/* Display page 0		*/
    regs.x.cx = 1;	/* # of times to write		*/

    int86( VIDEO_INT, &regs, &regs );
}
