#include "vbios.h"

void	vb_setcur( posn )
unsigned short	posn;
{
    /* Modify current cursor position. The top byte of
     * "posn" value holds the row (y), the bottom byte,
     * the column (x). The top-left corner of the screen
     * is (0,0). Pagenum is the video page number.
     */

    union REGS	regs;

    regs.h.bh = vb_getpage() ;
    regs.x.dx = posn	 ;
    regs.h.ah = SET_POSN	 ;
    int86( VIDEO_INT, &regs, &regs );
}
